function theta(x) !Heaviside function, useful in DSP
  implicit none
  real :: theta
  real, intent(in) :: x

  theta = 1.0
  if (x < 0.0 ) theta = 0.0
end function theta

function sinc(x) !sinc function as used in DSP
  implicit none
  real :: sinc, xpi
  real, intent(in) :: x
  real, parameter :: pi = acos(-1.0)

!  x = x*pi ! compiler error: x has intent in we need another variable:
  xpi = x*pi 

  sinc = 1.0
  if (xpi /= 0.0) sinc = sin(xpi)/xpi
end function sinc

function rect(t, tau) !generalized rectangular function, useful in DSP
  implicit none
  real :: rect
  real, intent(in) :: t, tau
  real :: abs_t, half_tau
  real, external :: theta

  abs_t = abs(t)
  half_tau = 0.5*tau
  rect = 0.5
  if (abs_t /= half_tau) rect = theta(half_tau-abs_t)
end function rect
